---
title: Using the aria-required attribute
slug: Web/Accessibility/ARIA/ARIA_Techniques/Using_the_aria-required_attribute
tags:
  - ARIA
  - Accessibility
  - NeedsContent
---
<div>
<div>
<h3 id="Description">Description</h3>

<p><span class="seoSummary">The <a class="external" href="https://www.w3.org/TR/wai-aria/#aria-required" title="http://www.w3.org/TR/wai-aria/states_and_properties#aria-required"><code>aria-required</code></a> attribute is used to indicate that user input is required on an element before a form can be submitted. This attribute can be used with any typical HTML form element; it is not limited to elements that have an ARIA <code>role</code> assigned.</span></p>

<p>{{ HTMLVersionInline("5") }} now has the <code>required</code> attribute, but aria-required is still useful for user agents that do not yet support HTML5.</p>

<h3 id="Value">Value</h3>

<p><code>true</code> or <code>false</code> (Default: <code>false</code>)</p>

<h3 id="Possible_effects_on_user_agents_and_assistive_technology">Possible effects on user agents and assistive technology </h3>

<p>Screen readers should announce the field as required.</p>

<p>Note that this attribute will not automatically change the presentation of the field.</p>

<div class="note"><strong>Note:</strong> Opinions may differ on how assistive technology should handle this technique. The information provided above is one of those opinions and therefore not normative.</div>

<h3 id="Examples">Examples</h3>

<h4 id="Example_1_A_simple_form">Example 1: A simple form</h4>

<pre class="brush: html notranslate"> &lt;form action="post"&gt;
     &lt;label for="firstName"&gt;First name:&lt;/label&gt;
     &lt;input id="firstName" type="text" aria-required="true" /&gt;
     &lt;br/&gt;
     &lt;label for="lastName"&gt;Last name:&lt;/label&gt;
     &lt;input id="lastName" type="text" aria-required="true" /&gt;
     &lt;br/&gt;
     &lt;label for="streetAddress"&gt;Street address:&lt;/label&gt;
     &lt;input id="streetAddress" type="text" /&gt;
 &lt;/form&gt;
</pre>

<h4 id="Working_Examples">Working Examples:</h4>

<p><a class="external" href="http://www.oaa-accessibility.org/examplep/tooltip1/">Tooltip example</a> (includes the use of the <code>aria-required</code> attribute)</p>

<h3 id="Notes">Notes </h3>

<h3 id="Used_in_ARIA_roles">Used in ARIA roles</h3>

<ul>
 <li>Combobox</li>
 <li>Gridcell</li>
 <li>Listbox</li>
 <li>Radiogroup</li>
 <li>Spinbutton</li>
 <li><a href="/en/Accessibility/ARIA/ARIA_Techniques/Using_the_textbox_role" title="Using the textbox role">Textbox</a></li>
 <li>Tree</li>
</ul>

<h3 id="Related_ARIA_techniques">Related ARIA techniques</h3>

<ul>
 <li><a href="/en/Accessibility/ARIA/ARIA_Techniques/Using_the_aria-invalid_attribute" title="Using the aria-invalid property">Using the aria-invalid attribute</a></li>
</ul>

<h3 id="Compatibility">Compatibility</h3>

<p class="comment">TBD: Add support information for common UA and AT product combinations</p>

<h3 id="Additional_resources">Additional resources</h3>

<ul>
 <li><a class="external" href="https://www.w3.org/TR/wai-aria/#aria-required" title="http://www.w3.org/TR/wai-aria/states_and_properties#aria-required">WAI-ARIA specification for <code>aria-required</code></a></li>
 <li><a class="external" href="http://www.w3.org/TR/wai-aria-practices/#ariaform">WAI-ARIA Authoring Practices for forms</a></li>
 <li><a href="/en/HTML/HTML5/Constraint_validation" title="Constraint validation">Constraint validation</a> in {{ HTMLVersionInline("5") }}</li>
</ul>
</div>
</div>
